/* Generated by Together */

import java.util.*;
//import java.lang.*;

/**
 * @invariants (geldreserve>=0) and (fehlVersuche<=3)
 */

public class Geldautomat {

	/**
	 * @supplierCardinality 0..1
	 * @clientCardinality 0..1
	 * @label eingefuehrt
	 */
	private InterneKarte karte;

	/**
	 * @label erstellt
	 * @clientCardinality 1
	 * @supplierCardinality 0..*
	 */
	private Abhebung lnkAbhebung;

	/**
	 * @clientCardinality 1..*
	 * @supplierCardinality 1
	 */
	AktuellesDatum datum = AktuellesDatum.getInstance();

	private int geldreserve = 1000000000;
	private int tagesLimit = 1000;
	private int offlineLimit = 1000;
	private boolean online = true;
	private boolean pinOkay;
	Zentralrechner zentralrechner = Zentralrechner.getInstance();

	int eingabe, fehlVersuche, kontoNr, kundenNr;
	int guthaben, neuesguthaben;
	private Konto konto;
	private Vector offlineAbhebungen;
	private Vector bestellteAuszuege = new Vector();
	private Vector einbehalteneKarten = new Vector();
	private Vector automatenBuchungen = new Vector();


	public Geldautomat( boolean isOnline) {
		
		this.online= isOnline;
		
	}
	
	public int gibGeldreserve(){
		return geldreserve;
	}
	
	public int gibOfflineLimit(){
			return offlineLimit;
		}
 
    /**
     * @postconditions (( eingabe = tmpkarte.pin) implies (result = true))
     * */
	public boolean pruefePIN(int eingabe, KarteTemporaer tmpkarte) {
		try {
			if (eingabe == tmpkarte.gibPin()) {
				pinOkay = true;
				return true;
			} 
			else 
			{
				tmpkarte.setzFalschePin(tmpkarte.gibFalschePin()+1);
				fehlVersuche=tmpkarte.gibFalschePin();
				
				if (fehlVersuche == 3) 
				{
					//Integer kartennummer = new Integer(tmpkarte.gibKartenNr());
					if (online)
					{ //zentralrechner.sperreKarte(kartennummer);
					}
					else 
					{//einbehalteneKarten.addElement(kartennummer);
					}
				 
					tmpkarte = null;
					
				}
				return false;
			}
		}
		//if karte==null
		catch (Exception e) {
			return false;
		}

	}

	public boolean gibStatus() {
		return online;
	}
	public void aenderStatus() {
		 online=!online;
		 if (online==true){
		 	synchronisiere();
		 }
		}

	public void synchronisiere(){
		zentralrechner.nacharbeiten(bestellteAuszuege, einbehalteneKarten,automatenBuchungen);
		bestellteAuszuege.clear();
		einbehalteneKarten.clear();
		automatenBuchungen.clear();
	}


	public boolean pruefeKartengueltigkeit(KarteTemporaer tmpkarte) {
		boolean kartengueltigkeit = false;
		if (online) {
			if (zentralrechner.karteGueltig(tmpkarte.gibKartenNr()) == true)
				kartengueltigkeit = true;
			else
				kartengueltigkeit = false;
		} else
			//bei offline muss sie wohl als gltig angenommen werden
			kartengueltigkeit = true;
		return kartengueltigkeit;
	}

	public boolean pruefeGeldreserve(int betrag) {
		if (geldreserve >= betrag)
			return true;
		else
			return false;
	}
	
	
	public void setzeGeldreserve(int betrag) {

		geldreserve -= betrag;
	}
	
	
	public void setzeGeldreserveNeu(int betrag) {

			geldreserve = betrag;
		}
		
		
	public void setzeTagesLimit(int betrag) {

			tagesLimit = betrag;
			
		}
		
		
	public void setzeOfflineLimit(int betrag) {

			offlineLimit = betrag;
		}
		
		
	public boolean pruefeLimits(KarteTemporaer tmpkarte, int betrag) {
		if (online) {
			tmpkarte.setzeOff((int)offlineLimit);
			Datum jetzt=new Datum();
			if ((jetzt.gibTag()!=tmpkarte.tag())|| (jetzt.gibMonat()!=tmpkarte.monat()))
			{tmpkarte.setzeOn((int)tagesLimit);
			}
			
			
			Konto konto=zentralrechner.gibKonto(tmpkarte.gibKontoNr());
			if ((tmpkarte.gibrestBetrag() >= betrag)&&(konto.gibKontostand()>=betrag))
				return true;
			else
				return false;
		} else {
			Datum jetzt=new Datum();
				if ((jetzt.gibTag()!=tmpkarte.tag())|| (jetzt.gibMonat()!=tmpkarte.monat()))
				{
					tmpkarte.setzeOn((int)tagesLimit);
				}
				//offline muss gegebenenfalls ebenfalls das tageslimit zurckgesetzt werden
			if ((tmpkarte.gibrestBetragOffline() >= betrag)&&(tmpkarte.gibrestBetrag()>=betrag))
				//offline werden tageslimit wie auch offlinelimit geprft
				return true;

			else
				return false;
		}
	}
	

	public void setzeLimits(KarteTemporaer tmpkarte, int betrag) {
		if (online)
			tmpkarte.setzrestBetrag(betrag);

		else{
			tmpkarte.setzeRestBetragOffline(betrag);
			/* wenn der automat offline ist, wird das tageslimit mit runtergesetzt, 
			 * um ein zu hohes abheben a einem tag zu vermeiden
			*/
			tmpkarte.setzrestBetrag(betrag);
		}
		tmpkarte.gibKarteAus();
	}


	public KarteTemporaer erstelleTmpKarte(int[] werte) {
		KarteTemporaer tmpkarte = new KarteTemporaer(werte);
		return tmpkarte;
	}

	public void karteAusgeben(KarteTemporaer tmpkarte) {

		//  Karte  und Authorisierung loeschen
		tmpkarte.gibKarteAus();
		tmpkarte = null;
		pinOkay = false;
		fehlVersuche = 0;
		konto = null;

	}

	//Kontoauszugsanforderung beim RZ melden, falls online oder im Vektor puffern.
	public void kontoauszugSchickenOn(KarteTemporaer tmpkarte, boolean teuro) {

		try {
			if (pinOkay == true) {
				
					zentralrechner.kontoauszugZuSchicken(
						tmpkarte.gibKontoNr(),
						tmpkarte.gibKundenNr(),
						teuro);

				
				
				
			}
		} catch (Exception e) {

			// keine Karte drin
		}
	}
	public void kontoauszugSchickenOff(KarteTemporaer tmpkarte) {

			try {
				if (pinOkay == true) {
					

					
						Datum jetzt=new Datum();
						Auszugsanforderung auszugsAnforderung =
						new Auszugsanforderung(tmpkarte.gibKontoNr(),jetzt);
						bestellteAuszuege.add(auszugsAnforderung);

					
				}
			} catch (Exception e) {

				// keine gltige Karte drin
			}
			

		}

	public int gibKontostand(KarteTemporaer tmpkarte) {

		if (pinOkay) {
			try {
				Konto konto = zentralrechner.gibKonto(tmpkarte.gibKontoNr());
				int aa = konto.gibKontostand();
				return aa;
			} catch (Exception e) {
				return 0;
			}
		}
		return 0; //noch ne println?
	}

	/**
		 * @input betrag:int
		 * @preconditions (geldreserve)>(betrag) and 
		 * (betrag<=tmpkarte.restBetrag) and
		 * (not (tmpkarte = null)) and
		 * if(online) then (betrag<= tmpkarte.konto.kontostand) else (betrag<=tmpkarte.restBetragOffline)
		 * endif
		 * @postconditions online implies
		 * (tmpkarte.konto.kontostand = tmpkarte.konto.kontostand@pre - betrag)
		 */

	public void fuehreAbhebungDurch(int betrag, KarteTemporaer tmpkarte) {
		if (online) {
			Datum jetzt=new Datum();
			Abhebung abhebung =
				new Abhebung(jetzt, tmpkarte.gibKonto(), betrag);
			zentralrechner.bearbeiteAbhebung(abhebung);
			//tmpkarte.setzDatum(datum);

		} else {
			Datum jetzt=new Datum();
			Abhebung abhebung =
				new Abhebung(jetzt, tmpkarte.gibKontoNr(), betrag);
			//automatenBuchungen.add(abhebung);
		}
	}

}
