/* Generated by Together */

import java.util.*;
public class Zentralrechner {

	/**
	 * @clientCardinality 1
	 * @supplierCardinality 1..*
	 * @label verwaltet
	 */
	private Vector kunden = new Vector();

	/**
	 * @clientCardinality 1
	 * @supplierCardinality 1..*
	 * @label verwaltet
	 */
	private Vector konten = new Vector();

	/**
	 * @clientCardinality 1
	 * @supplierCardinality 1..*
	 * @label interagiert
	 */
	//private Vector geldautomaten = new Vector();

	/**
	 * @clientCardinality 1
	 * @supplierCardinality 1
	 */
	private Datum datum = new Datum();
	private Vector karten = new Vector();
	private Vector autom = new Vector();
	private Konto dieskonto, dieseskonto;
	int kundennummern = 0;

	Subject subject = new Subject();

	// Singleton-Design-Pattern:
	// es gibt nur eine einzige Instanz des Zentralrechners!

	private static Zentralrechner instance = null;

	public static Zentralrechner getInstance() {
		if (instance == null) {
			instance = new Zentralrechner();
		}
		return instance;
	}

	private Zentralrechner() {

	}

	public void attach(Observer observer) {
		subject.attach(observer);
	}
	
	public void detach(Observer observer) {
		subject.detach(observer);
	}
	public void initVector() {

		for (int i = 0; i < 10; i++) {
			Geldautomat geldautomat = new Geldautomat( true);
			autom.add(geldautomat);

		}

	}

	public Geldautomat gibAutomaten(int position) {
		Geldautomat a = (Geldautomat)(autom.get(position));
		return a;
	}

	public boolean sucheAutomaten(int nummer) {
		boolean da = false;
		if (nummer <= autom.size())
			da = true;
		return da;
	}

	public void fuegeAutomatenHinzu() {
		Geldautomat geldautomat = new Geldautomat(true);
		autom.add(geldautomat);

	}

	public void loescheAutomaten(int nummer) {

		autom.remove(nummer);
	}

	public int anzahlAutomaten() {
		return autom.size();
	}


	public int neuerKunde(
		String vorname,
		String nachname,
		String strasse,
		String nummer,
		String stadt,
		int postleitzahl) {
		kundennummern++;
		int kundenNr = kundennummern;
		Kunde neuerKunde =
			new Kunde(
				kundenNr,
				vorname,
				nachname,
				strasse,
				nummer,
				stadt,
				postleitzahl);
		kunden.addElement(neuerKunde);
		subject.fireUpdate();
		return kundenNr;
	}

	public int anzahlKunden() {
		return kunden.size();
	}

	public boolean gibtEsKunden(int kundenNr) {
		boolean gibtEs = false;
		for (int i = 0; i < kunden.size(); i++) {
			if (((Kunde) kunden.get(i)).gibKundenNr() == kundenNr)
				gibtEs = true;
		}
		return gibtEs;
	}

	public Kunde gibKunde(int kundenNr) {
		Kunde gesuchterKunde = null;
		for (int i = 0; i < kunden.size(); i++) {
			if (((Kunde) kunden.get(i)).gibKundenNr() == kundenNr)
				gesuchterKunde = (Kunde) kunden.get(i);
		}
		return gesuchterKunde;
	}

	public int neuesKonto(int kundenNr) {
		Kunde ku = gibKunde(kundenNr);
		int kontoNr = (kundenNr * 1000) + ku.gibAnzahlKonten() + 1;
		Konto neuesKonto = new Konto(kundenNr, kontoNr);
		konten.addElement(neuesKonto);
		ku.kontoHinzufuegen(kontoNr);
		subject.fireUpdate();
		return kontoNr;
	}

	public int anzahlKonten() {
		return konten.size();
	}

	public boolean gibtEsKonto(int kontoNr) {
		boolean gibtEs = false;
		for (int i = 0; i < konten.size(); i++) {
			if (((Konto) konten.get(i)).gibKontoNr() == kontoNr)
				gibtEs = true;
		}
		return gibtEs;
	}

	public Konto gibKonto(int kontoNr) {
		Konto gesuchtesKonto = null;
		for (int i = 0; i < konten.size(); i++) {
			if (((Konto) konten.get(i)).gibKontoNr() == kontoNr)
				gesuchtesKonto = (Konto) konten.get(i);
		}
		return gesuchtesKonto;
	}

	public int neueKarte(int kundenNr, int kontoNr) {
		Kunde ku = gibKunde(kundenNr);
		Konto ko = gibKonto(kontoNr);
		int kartenNr = (kontoNr * 1000) + ko.gibAnzahlKarten() + 1;
		int pin = kundenNr * 10;

		InterneKarte neueKarte = new InterneKarte(kartenNr, kontoNr, kundenNr);

		ExterneKarte.schreibeAufExterneKarte(
			kartenNr,
			kontoNr,
			kundenNr,
			pin,
			0,
			1000,
			1000
			,0,0);
		karten.addElement(neueKarte);
		ku.karteHinzufuegen(kartenNr);
		ko.karteHinzufuegen(kartenNr);
		subject.fireUpdate();
		return kartenNr;
	}

	public int anzahlKarten() {
		return karten.size();
	}

	public boolean gibtEsKarte(int kartenNr) {
		boolean gibtEs = false;
		for (int i = 0; i < karten.size(); i++) {
			if (((InterneKarte) karten.get(i)).gibKartenNr() == kartenNr)
				gibtEs = true;
		}
		return gibtEs;
	}

	public InterneKarte gibKarte(int kartenNr) {
		InterneKarte gesuchteKarte = null;
		for (int i = 0; i < karten.size(); i++) {
			if (((InterneKarte) karten.get(i)).gibKartenNr() == kartenNr)
				gesuchteKarte = (InterneKarte) karten.get(i);
		}
		return gesuchteKarte;
	}

	public void bearbeiteAbhebung(Abhebung abhebung) {

//		dieskonto = gibKonto(abhebung.gibKontoNr());
		dieskonto = abhebung.gibKonto();
		dieskonto.betragVerbuchen(abhebung.gibBetrag(), abhebung);

	}

	public void nacharbeiten(
		Vector bestellteAuszuege,
		Vector einbehalteneKarten,
		Vector automatenBuchungen) {
		Abhebung abhebung;
		Integer karte;
		Auszugsanforderung auszug;

		while (!automatenBuchungen.isEmpty()) {
			abhebung = (Abhebung) (automatenBuchungen.firstElement());
			bearbeiteAbhebung(abhebung);
			automatenBuchungen.removeElementAt(0);
		}
		while (!einbehalteneKarten.isEmpty()) {
			karte = (Integer) (einbehalteneKarten.firstElement());
			sperreKarte(karte);
			einbehalteneKarten.removeElementAt(0);
		}
		while (!bestellteAuszuege.isEmpty()) {
			auszug = (Auszugsanforderung) (bestellteAuszuege.firstElement());
			Konto konto = gibKonto(auszug.gibKontonummer());
			boolean teuro = konto.auszugKostet();
			kontoauszugZuSchicken(
				konto.gibKontoNr(),
				konto.gibKundenNr(),
				teuro);
			bestellteAuszuege.removeElementAt(0);
		}

	}

	public void sperreKarte(Integer num) {
		int nummer = num.intValue();
		InterneKarte sperrkarte = gibKarte(nummer);
		sperrkarte.sperreKarte();
	}

	public void kontoauszugZuSchicken(
		int kontoNummer,
		int kundenNummer,
		boolean teuro) {

		dieseskonto = gibKonto(kontoNummer);
		Datum jetzt=new Datum();
		Auszugsanforderung anforderung =
			new Auszugsanforderung(kontoNummer, jetzt);

		dieseskonto.kontoauszugErstellen();
		dieseskonto.abhebungenloeschen();

		if (teuro) {
			
			Abhebung abhebung = new Abhebung(jetzt, kontoNummer, 1);
			bearbeiteAbhebung(abhebung);
		}

	}
	public boolean karteGueltig(int kartenNr) {
		InterneKarte ik = gibKarte(kartenNr);
		if (ik != null)
			return (ik.KarteStatus());
		else
			return false;

	}
}
